//xsetaseta@gmail.com
//Libreria RF24master  Copyright (C) 2011 J. Coliz <maniacbug@ymail.com>
//   23/03/2018
//Para el coche nikko

#define DEBUG 

  #include <SPI.h> 
  #include <nRF24L01.h>
  #include <RF24.h>

  #define CE 8
  #define CSN 7

  RF24 radio(CE, CSN);

  const uint64_t tuberia = 0xE8E8F0F0E1LL;
  char dato[20];

  #define PIN_D02 2   //motor
  #define PIN_V1 9
  
  #define PIN_D03 3    //Direccion
  #define PIN_V2 10
  
  #define PIN_D04 4  //LED
  #define PIN_D05 5  
  
  bool done;
  int z,anterior;
  
  byte SENSOR0,SENSOR1,SENSOR2,SENSOR3 ;
  byte ENTRADAS;
  
void setup() 
  {
    Serial.begin(9600);
    Serial.println("Receptor mando1");
    radio.begin();
    radio.setChannel(50);  
    radio.openReadingPipe(1, tuberia); 
    radio.startListening(); 
    pinMode(PIN_D02,OUTPUT);
    pinMode(PIN_D03,OUTPUT);
    pinMode(PIN_V1,OUTPUT);
    pinMode(PIN_V2,OUTPUT);
    
    pinMode(PIN_D04,OUTPUT);
    pinMode(PIN_D05,OUTPUT);

    digitalWrite(PIN_D02, LOW);
    digitalWrite(PIN_D03, LOW);
    digitalWrite(PIN_V1, LOW);
    digitalWrite(PIN_V2, LOW);
  }
  
void loop(void)
{ 
  delay(1);
  
  z++;
  if(z>500)
  {    
    digitalWrite(PIN_D02, LOW);
    digitalWrite(PIN_D03, LOW);
    digitalWrite(PIN_V1, LOW);
    digitalWrite(PIN_V2, LOW);
    Serial.println("No SIGNAL");
    
    z=0;
  }
   
   
  while(radio.available()) 
    {
      radio.read(dato, 7);
      SENSOR0=dato[0]; SENSOR1=dato[1];
      SENSOR2=dato[2]; SENSOR3=dato[3];
      ENTRADAS=dato[4];
   #ifdef DEBUG 
      Serial.print(ENTRADAS,BIN);  Serial.print(" ");
      Serial.print(SENSOR0);Serial.print(" "); Serial.print(SENSOR1); Serial.print(" ");
      Serial.print(SENSOR2);Serial.print(" "); Serial.println(SENSOR3);   
   #endif     
      done=1;  
    }
 
 
 if (done)
      { 
       //LED
      if( ENTRADAS & 4)
        digitalWrite(PIN_D04, HIGH);
       else
        digitalWrite(PIN_D04, LOW);
        
      if( ENTRADAS & 8)
        digitalWrite(PIN_D05, HIGH);
       else
        digitalWrite(PIN_D05, LOW);
        
      //Parar        
      if((SENSOR1>120 && SENSOR1<136 && SENSOR0>120 && SENSOR0<136) || (SENSOR1==0 && SENSOR1==0 && SENSOR0==0 && SENSOR0==0 ) )
        {
          anterior=0;
          digitalWrite(PIN_D02, LOW);
          digitalWrite(PIN_D03, LOW);
          digitalWrite(PIN_V1, LOW);
          digitalWrite(PIN_V2, LOW);
          z=0;
          goto salto;
        }
        
       //Adelante
       if(SENSOR1<64)
       {
           Serial.println(">");
           digitalWrite(PIN_D02, LOW);
           digitalWrite(PIN_V1, HIGH);
           /* Esta rutina es para variacin de velocidad, con los circuito de nikko no funciona
           if(anterior==0)
             {
               analogWrite(PIN_V1,255);
               anterior=1;
               delay(90);
             }
            analogWrite(PIN_V1,SENSOR2);
           */        
           z=0; 
           goto salto1;
        }
        
        //Atras
         if(SENSOR1>192)
        {
          Serial.println("<");
          digitalWrite(PIN_D02, HIGH);
          digitalWrite(PIN_V1, LOW);
          /* Esta rutina es para variacin de velocidad, con los circuito de nikko no funciona
          if(anterior==0)
             {
               analogWrite(PIN_V1,0);
               anterior=1;
               delay(90);
             }
          analogWrite(PIN_V1,255-SENSOR2);
          */ 
           z=0;
        }
salto1:        
        //Izquierda
       if(SENSOR0<80)
        {
           digitalWrite(PIN_D03, HIGH);
           analogWrite(PIN_V2,0);
           z=0;         
        }
        else        
        //Derecha
        if(SENSOR0>176)
        {  
           analogWrite(PIN_V2,255);
           analogWrite(PIN_D03,0); 
           z=0;
        }
        else
        {
          // CENTRAR
          digitalWrite(PIN_D03, LOW);
          analogWrite(PIN_V2,0);
          z=0; 
        }
      ;
salto:
        done=0;
      }
 
 
}

