//xsetaseta@gmail.com
//Libreria RF24master  2011 J. Coliz <maniacbug@ymail.com>
//    23/03/2018  

// #define DEBUG 

#include <SPI.h> 
#include <nRF24L01.h>
#include <RF24.h>

#define CE 8
#define CSN 7

RF24 radio(CE, CSN);

const uint64_t tuberia = 0xE8E8F0F0E1LL;

char dato[10];


#define ANA0  A0
#define ANA1  A1
#define ANA2  A2
#define ANA3  A3

#define DIGI0  2
#define DIGI1  3
#define DIGI2  4
#define DIGI3  5

unsigned int SENSOR0,SENSOR1,SENSOR2,SENSOR3 ;
byte ENTRADAS;

void setup() 
{
  Serial.begin(9600);

   pinMode(ANA0, INPUT);
   pinMode(ANA1, INPUT);
   pinMode(ANA2, INPUT);
   pinMode(ANA3, INPUT);
   pinMode(DIGI0, INPUT);
   pinMode(DIGI1, INPUT);
   pinMode(DIGI2, INPUT);
   pinMode(DIGI3, INPUT);
   
   Serial.println("Emisor COCHE mando");
   radio.begin(); 
   radio.setChannel(50); 	
   radio.openWritingPipe(tuberia); 
}

void loop() 
{
  delay(70);
 
  SENSOR0 = analogRead(ANA0)>>2;
  SENSOR1 = analogRead(ANA1)>>2; SENSOR1 =255-SENSOR1;
  SENSOR2 = analogRead(ANA2)>>2; SENSOR2 =255-SENSOR2;
  SENSOR3 =255;
  //SENSOR3 = analogRead(ANA2)>>2;

  ENTRADAS=128; 
  if(!digitalRead(DIGI0)) ENTRADAS|=1;   
  if(!digitalRead(DIGI1)) ENTRADAS|=2;
  if(!digitalRead(DIGI2)) ENTRADAS|=4;
  if(!digitalRead(DIGI3)) ENTRADAS|=8;


  Serial.print(SENSOR0); Serial.print(" ");
  Serial.print(SENSOR1); Serial.print(" ");
  Serial.print(SENSOR2); Serial.print(" ");
  Serial.print(SENSOR3); Serial.print(" ");
  Serial.println(ENTRADAS,BIN);


  dato[0]=SENSOR0; dato[1]=SENSOR1; 
  dato[2]=SENSOR2; dato[3]=SENSOR3; 
  dato[4]=ENTRADAS;
  enviarS();     

}


void enviarS()
{
     radio.write(dato, 7); 
#ifdef DEBUG      
     Serial.println(ENTRADAS,BIN);
#endif     
     delay(10);
}
